//
//  BundleJsonHelper.swift
//  Una serie di funzioni utili per evitare di ripetere sempre gli stessi task.
//  Crediti a Paul Hudson, creatore di Hacking With Swift. http://www.hackingwithswift.com
//
//  Created by Simone Figlie' on 24/08/20.
//  Copyright © 2020 Simone Figlie'. All rights reserved.
//

import Foundation

extension Bundle {
    func decode<T: Decodable>(_ type: T.Type, from file: String) -> T {
        guard let url = self.url(forResource: file, withExtension: nil) else {
            fatalError("Failed to locate \(file) in bundle.")
        }

        guard let data = try? Data(contentsOf: url) else {
            fatalError("Failed to load \(file) from bundle.")
        }

        let decoder = JSONDecoder()

        do {
            let loaded = try decoder.decode(T.self, from: data)
            return loaded
        } catch let error {
            fatalError("Failed to decode \(file) from bundle: \(error)")
        }
        
//        guard let loaded = try? decoder.decode(T.self, from: data) else {
//            fatalError("Failed to decode \(file) from bundle.")
//        }
//
//        return loaded
    }
}
